CrowdControl = require "CCLuaBase"
local Success = 0
local Failure = 1
local Unavailable = 2
local Retry = 3
local Pause = 6
local Resumed = 7
local Stopped = 8


local invul = nil
local invultimer = -1.0
local invulid = 0

local ohko = nil
local ohkotimer = -1.0
local ohkoid = 0

local scalehold = false

local giant = nil
local gianttimer = -1.0
local giantid = 0

local tiny = nil
local tinytimer = -1.0
local tinyid = 0

local esize = nil
local esizetimer = -1.0
local esizeid = 0

local speed = nil
local speedtimer = -1.0
local speedid = 0

local FOV = 81.0
local fovtimer = -1.0
local fovid = 0

local espeed = nil
local espeedtimer = -1.0
local espeedid = 0

local lasttime = 0

local paused = false
local spawns = true

--local isRE2 = true

local healing = {
    spray = 1,
    herbg = 2,
    herbr = 3,
    herbb = 4,
    herbgg = 5,
    herbgr = 6,
    herbgb = 7,
    herbggb = 8,
    herbggg = 9,
    herbgrb = 10,
    herbrb = 11,    
}

local healup = {
    [2] = 5,
    [3] = 6,
    [4] = 7,
    [5] = 9,
    [6] = 10,
    [7] = 10,
    [11] = 10
}

local healdown = {
    [1] = 5,
    [5] = 2,
    [6] = 3,
    [7] = 4,
    [9] = 5,
    [10] = 6,
    [11] = 3,
    [8] = 7
}

local ammo = {
    handgun = 15,
    shotgun = 16,
    submachine = 17,
    mag = 18,
    acid = 22,--acid rounds
    flame = 23,--flame rounds
    needle = 24,--needle cartridges
    fuel = 25,
    large = 26,--large caliber handgun
    slshigh = 27,--high powered sls 60
    detonator = 31,
    ink = 32, --ink ribbon
    board = 33, --wooden boards
   
}

local weapon = {
    matilda = 1,
    m19 = 2,
    jmb = 3,--JMB Hp3
    quick = 4,--quickdraw army
    mup = 7,
    broom = 8,--Broom Hc
    sls60 = 9,
    w870 = 11,
    mq11 = 21,
    le5 = 23,--BIG
    lightning = 31,--Lightning Hawk
    emf = 41, --EMF Visualizerr
    gm79 = 42,
    flame = 43, --BIG Chemical Flamethrower
    spark = 44, --BIG Spark Shot
    atm4 = 45, --BIG
    knife = 46, --combat knife
    infknife = 47, --unbreakable knife
    antitank = 49, --BIG anti-tank rocket
    minigun = 50, --BIG
    grenade = 65, --hand grenade
    flash = 66, --flash grenade
}

local weaponammo = {
    matilda = 15,
    m19 = 15,
    jmb = 15,--JMB Hp3
    quick = 15,--quickdraw army
    mup = 15,
    broom = 15,--Broom Hc
    sls60 = 15,
    w870 = 16,
    mq11 = 17,
    le5 = 17,--BIG
    lightning = 18,--Lightning Hawk
    emf = 0, --EMF Visualizerr
    gm79 = 22,
    flame = 25, --BIG Chemical Flamethrower
    spark = 24, --BIG Spark Shot
    atm4 = 0, --BIG
    knife = 0, --combat knife
    infknife = 0, --unbreakable knife
    antitank = 0, --BIG anti-tank rocket
    minigun = 0, --BIG
    grenade = 0, --hand grenade
    flash = 0, --flash grenade
}

local weaponbig = {
    matilda = false,
    m19 = false,
    jmb = false,--JMB Hp3
    quick = false,--quickdraw army
    mup = false,
    broom = false,--Broom Hc
    sls60 = false,
    w870 = false,
    mq11 = false,
    le5 = true,--BIG
    lightning = false,--Lightning Hawk
    emf = false, --EMF Visualizerr
    gm79 = false,
    flame = true, --BIG Chemical Flamethrower
    spark = true, --BIG Spark Shot
    atm4 = true, --BIG
    knife = false, --combat knife
    infknife = false, --unbreakable knife
    antitank = true, --BIG anti-tank rocket
    minigun = true, --BIG
    grenade = false, --hand grenade
    flash = false, --flash grenade
}

function string:split(sep)
    local result = {}
    local regex = ("([^%s]+)"):format(sep)
    for each in self:gmatch(regex) do
       table.insert(result, each)
    end
    return result
 end

function string:contains(sub)
    return self:find(sub, 1, true) ~= nil
end

function string:startswith(start)
    return self:sub(1, #start) == start
end

function string:endswith(ending)
    return ending == "" or self:sub(-#ending) == ending
end

function string:replace(old, new)
    local s = self
    local search_start_idx = 1

    while true do
        local start_idx, end_idx = s:find(old, search_start_idx, true)
        if (not start_idx) then
            break
        end

        local postfix = s:sub(end_idx + 1)
        s = s:sub(1, (start_idx - 1)) .. new .. postfix

        search_start_idx = -1 * postfix:len()
    end

    return s
end

function string:insert(pos, text)
    return self:sub(1, pos - 1) .. text .. self:sub(pos)
end

local function get_enumerator(managed_object)
	local output = {}
	managed_object = managed_object:call("GetEnumerator") or managed_object
	local name = managed_object:get_type_definition():get_full_name()
	
	if name:find(">d") or name:find("Dictionary") or name:find("erable") then 
		--managed_object:call(".ctor", 0)
		while managed_object:call("MoveNext") do 
			local current = managed_object:call("get_Current")
			if current then 
				output[current:call("get_Key")] = current:call("get_Value")
			end
		end
	else
		while managed_object:call("MoveNext") do 
			table.insert(output, managed_object:get_field("mCurrent"))
		end
	end
	return output
end

re.on_pre_application_entry("BeginRendering", function(element, context)
    
    local flowman = sdk.get_managed_singleton("app.ropeway.gamemastering.MainFlowManager")
    if not flowman then
        CCLog('no flow manager')
        return false
    end

    local state = flowman:get_field("_CurrentMainState")
    if state ~= 6 then
        return true
    end

    local camera = sdk.get_primary_camera()
    if not camera then
        return true
    end
    camera:call("set_FOV", FOV);

    return true
end)

local function isGame()
    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))
    
    if not playman then
        return false
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return false
    end

    local health = condition:get_field("<HitPointController>k__BackingField")
    if not health then
        return false
    end

    local hp = health:call("get_CurrentHitPoint")
    if hp <= 0 then
        return false
    end

    return true
end

local function isReady()
    --
    --_CurrentMainState
    local flowman = sdk.get_managed_singleton("app.ropeway.gamemastering.MainFlowManager")
    if not flowman then
        CCLog('no flow manager')
        return false
    end

    local state = flowman:get_field("_CurrentMainState")
    if state ~= 6 then
        return false
    end


    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))
    
    if not playman then
        return false
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return false
    end

    local event = condition:get_field("<IsEvent>k__BackingField")
    if event then
        return false
    end

    local health = condition:get_field("<HitPointController>k__BackingField")
    if not health then
        return false
    end

    local hp = health:call("get_CurrentHitPoint")
    if hp <= 0 then
        return false
    end

    local guiman = sdk.get_managed_singleton(sdk.game_namespace("gui.GUIMaster"))
    if not guiman then
        return false
    end

    local open
    open = guiman:call("get_IsOpenInventory")
    if open then
        return false
    end
    open = guiman:call("get_IsOpenMap")
    if open then
        return false
    end
    open = guiman:call("get_IsOpenPause")
    if open then
        return false
    end
    open = guiman:call("get_IsOpenPauseForEvent")
    if open then
        return false
    end

    return true
end

local enemies = {}
local deferred_prefab_calls = {}
local spawned_prefabs = {}

local function spawn_deferred_prefab(packed_func_call)
	
    local scene = sdk.call_native_func(sdk.get_native_singleton("via.SceneManager"), sdk.find_type_definition("via.SceneManager"), "get_CurrentScene") 
    local spawned_prefabs_folder = scene:call("findFolder", "ModdedTemporaryObjects") or scene:call("findFolder", "GUI_Rogue")

    if not spawned_prefabs_folder then return nil end

	if not packed_func_call.packed_pfb or not packed_func_call.packed_pfb.prefab then 
		return nil
	end
	
	local pfb = packed_func_call.packed_pfb.prefab
	local gameobj = nil
	
	if not packed_func_call.already_exists then
		
		if not pcall(function()
			pfb:call("set_Standby", true)

            local args = packed_func_call.args

			gameobj = pfb:call(packed_func_call.func_name, args[1], args[2], spawned_prefabs_folder)--table.unpack(packed_func_call.args)) --spawn
		end) then 
			deferred_prefab_calls = {}
			return nil
		end
		
		if isRE2 or isRE3 then
			local guid = ValueType.new(sdk.find_type_definition("System.Guid")):call("NewGuid")
			emmgr:call("requestInstantiate", guid, packed_func_call.packed_pfb.type_id, packed_func_call.packed_pfb.name, emmgr:get_field("<LastPlayerStaySceneID>k__BackingField"), packed_func_call.args[1], packed_func_call.args[2], true, nil, nil)
			emmgr:call("execInstantiateRequests")
		end
	end
	
    if not gameobj then 
        if packed_func_call.packed_pfb.name then
            gameobj = scene:call("findGameObject(System.String)", packed_func_call.packed_pfb.name)
        end
    end

	local xform = gameobj and gameobj:call("get_Transform")
	
	if xform then 

        --local searchresults = scene:call("findComponents(System.Type)", sdk.typeof("app.ropeway.enemy.EmCommonParam"))
        --for i, result in ipairs(searchresults or {}) do
		--	local name = result:call("ToString()"):lower()
--
        --    CCLog('component found - '..name)
--
        --    pcall(sdk.call_object_func, result, "set_LoiteringEnable", true)
        --end
--
        return true


        --local searchresults = scene:call("findComponents")
        --for i, result in ipairs(searchresults or {}) do
			--local name = result:call("ToString()"):lower()

            --CCLog('all component found - '..name)
        --end
	--	local new_spawn = spawned_prefabs[xform] or GameObject:new{xform=xform}
	--	if not isDMC then
	--		new_spawn.is_loitering=SettingsCache.loiter_by_default
	--		for i, component in ipairs(new_spawn.components) do 
	--			local name = component:call("ToString()"):lower()
	--			if name:find("em%d%d") or name:find("enemy") and not name:find("hink") then
	--				if not pcall(sdk.call_object_func, component, "awake") then 
	--					log.info(name)
	--				end
    --                CCLog('awake - '..name)
	--			end
	--			if name:find("character") then 
	--				pcall(sdk.call_object_func, component, "warp")
	--			end
	--			if name:find("em%d%d%d%dparam") then
	--				pcall(sdk.call_object_func, component, "set_LoiteringEnable", true)
	--				new_spawn.emparam = component
	--			elseif name:find("loitering") then 
	--				if SettingsCache.loiter_by_default then 
	--					pcall(sdk.call_object_func, component, "requestLoitering")
	--				end
	--				new_spawn.loitering = component
	--			end
	--		end
	--	end
	--	
	--	packed_func_call.already_exists = true
	--	packed_func_call.counter = packed_func_call.counter + 1
	--	packed_func_call.xform = xform
	--	
	--	if packed_func_call.counter == 1 then -- awake+start the components two times
	--		deferred_prefab_calls[pfb] = nil
	--	end
	--	spawned_prefabs[xform] = new_spawn
	--	return new_spawn
	end
end

local function spawn_zombie(pfb_name, pfb, folder)
	
    local scene = sdk.call_native_func(sdk.get_native_singleton("via.SceneManager"), sdk.find_type_definition("via.SceneManager"), "get_CurrentScene") 
    local spawned_prefabs_folder = scene:call("findFolder", "ModdedTemporaryObjects") or scene:call("findFolder", 
    (isRE4 and "Test") or 
    (isRE2 and "GUI_Rogue") or 
    (isRE3 and "RopewayGrandSceneDevelop") or
    (isSF6 and "EmulatorContent") or 
    (isDMC and "Develop") or 
    (isMHR and "Item_b_000") or 
    (isRE8 and "Debug") or "")


	folder = folder or spawned_prefabs_folder 
	local pfb = pfb or (enemies and enemies[pfb_name] and enemies[pfb_name].prefab) 
	if not pfb then return false end
	pfb:call("set_Standby", true)
	local random_dir = Vector4f.new(math.random(-100,100)*0.01,  0.0, math.random(-100,100)*0.01, math.random(-100,100)*0.01):normalized():to_quat()
	
    local last_camera_matrix = sdk.get_primary_camera()
	if not last_camera_matrix then return false end
	last_camera_matrix = last_camera_matrix:call("get_WorldMatrix")
    
    local spawn_pos = last_camera_matrix[3] - (last_camera_matrix[2] * 1.0)

    

	
	local packed_pfb = (pfb and { prefab=pfb, name=pfb:call("get_Path"):match("^.+/(.+)%.pfb")}) or enemies[pfb_name]
	deferred_prefab_calls[pfb] = { func_name="instantiate(via.vec3, via.Quaternion, via.Folder)", args=table.pack(spawn_pos, random_dir, folder), counter=0, packed_pfb=packed_pfb }
	if pfb_name and pfb_name:find("arasite") then 
		deferred_prefab_calls[pfb].zombie = { func_name="instantiate(via.vec3, via.Quaternion, via.Folder)", args=table.pack(spawn_pos, random_dir, folder), counter=0, packed_pfb=enemies["em0000"] }
	end

    if not spawn_deferred_prefab(deferred_prefab_calls[pfb]) then return false end

    return true
end

local function CCKill()
    return Failure
end

local function CCSpawn(enemy)
    local scene = sdk.call_native_func(sdk.get_native_singleton("via.SceneManager"), sdk.find_type_definition("via.SceneManager"), "get_CurrentScene") 

    if not scene then return Failure end
    
    local registers = scene:call("findComponents(System.Type)", sdk.typeof(sdk.game_namespace("EnemyDataManager")))
    registers = registers and registers.get_elements and registers:get_elements() or {}
    if not registers then return Failure end
    
    for i, registry in ipairs(registers) do 
        local pfb_dict = get_enumerator(registry:call("get_EnemyDataTable"))
        for type_id, pfb_register in pairs(pfb_dict) do 
            local prefab_ref = pfb_register:get_field("Prefab")
            prefab_ref:call("set_DefaultStandby", true)
            local via_prefab = prefab_ref:get_field("PrefabField")
            local name = via_prefab:call("get_Path"):match("^.+/(.+)%.pfb")
            if not name:find("em0[678]00") then --no low-LOD zombies
                enemies[name:lower()] = { prefab=via_prefab, name=name, type_id=type_id, ref=prefab_ref }
                CCLog('enemy: ' .. name)
            end
        end
    end

    if not spawn_zombie(enemy) then return Retry end

    return Success
end

local function SetSpeed(val)
    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return Retry
    end

    local motion = condition:get_field("<Motion>k__BackingField")
    if not motion then
        return Retry
    end

    motion:call("set_SecondaryPlaySpeed",val)


    return Success
end

local function SetEnemySpeed(val)
    local enemyman = sdk.get_managed_singleton("app.ropeway.EnemyManager")

    if not enemyman then
        return Retry
    end

    local list = enemyman:get_field("<ActiveEnemyList>k__BackingField")--enemyman:call("get_ActiveEnemyList")

    if not list then
        return Retry
    end

    local found = false

    local size = list:get_field("mSize")

    for i=0,size-1 do
        local v = list[i]

        if v then
            local cur = v:get_field("<BaseMotionSpeed>k__BackingField")

            CCLog('enemy speed: ' .. cur)

            v:set_field("<BaseMotionSpeed>k__BackingField",val)
            found = true
        end
        
    end


    if not found then
        return Retry
    end

    return Success
end

local function CCWide()
    if fovtimer > 0 then
        return retry
    end

    FOV = 130.0

    return Success
end

local function CCNarrow()
    if fovtimer > 0 then
        return retry
    end

    FOV = 50.0

    return Success
end

local function CCFast()
    if speed ~= nil then
        return retry
    end

    speed = 3.0

    return Success
end

local function CCSlow()
    if speed ~= nil then
        return retry
    end

    speed = 0.33

    return Success
end

local function CCEFast()
    if espeed ~= nil then
        return retry
    end

    espeed = 2.0

    return Success
end

local function CCESlow()
    if espeed ~= nil then
        return retry
    end

    espeed = 0.5

    return Success
end

local function CCHyper()
    if speed ~= nil then
        return retry
    end

    speed = 8.0

    return Success
end


local function CCDamage()

    if ohko ~= nil then
        return retry
    end
    if invul ~= nil then
        return retry
    end

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return Retry
    end

    local health = condition:get_field("<HitPointController>k__BackingField")
    if not health then
        return Retry
    end


    local hp = health:call("get_CurrentHitPoint")
    local max = health:call("get_DefaultHitPoint")

    local del = max // 4

    if hp < del / 2 then
        return Retry
    end
    
    if hp <= del then
        hp = 1
    else
        hp = hp - del
    end

    health:call("set_CurrentHitPoint", hp)
    
    return Success
end

local function CCEDamage()
    local enemyman = sdk.get_managed_singleton("app.ropeway.EnemyManager")

    if not enemyman then
        return Retry
    end

    local list = enemyman:get_field("<ActiveEnemyList>k__BackingField")--enemyman:call("get_ActiveEnemyList")

    if not list then
        return Retry
    end

    local found = false

    local size = list:get_field("mSize")
    
    for i=0,size-1 do
        local v = list[i]

        if v then

            local health = v:get_field("<HitPoint>k__BackingField")
            if not health then
                return Retry
            end


            local hp = health:call("get_CurrentHitPoint")
            local max = health:call("get_DefaultHitPoint")

            local del = max // 4

            if hp >= del / 2 then
                            
                if hp <= del then
                    hp = 1
                else
                    hp = hp - del
                end

                health:call("set_CurrentHitPoint", hp)
                found = true
            end
        end
    end
    
    if not found then
        return Retry
    end

    return Success
end

local function CCEHeal()
    local enemyman = sdk.get_managed_singleton("app.ropeway.EnemyManager")

    if not enemyman then
        return Retry
    end

    local list = enemyman:get_field("<ActiveEnemyList>k__BackingField")--enemyman:call("get_ActiveEnemyList")

    if not list then
        return Retry
    end

    local found = false

    local size = list:get_field("mSize")
    
    for i=0,size-1 do
        local v = list[i]

        if v then

            local health = v:get_field("<HitPoint>k__BackingField")
            if not health then
                return Retry
            end


            local hp = health:call("get_CurrentHitPoint")
            local max = health:call("get_DefaultHitPoint")

            local del = max // 4

            if hp <= max - del / 2 then
                    
                if hp + del > max then
                    hp = max
                else
                    hp = hp + del
                end

                health:call("set_CurrentHitPoint", hp)
                
                found = true
            end
        end
    end
    
    if not found then
        return Retry
    end

    return Success
end


local function CCEOneHP()
    local enemyman = sdk.get_managed_singleton("app.ropeway.EnemyManager")

    if not enemyman then
        return Retry
    end

    local list = enemyman:get_field("<ActiveEnemyList>k__BackingField")--enemyman:call("get_ActiveEnemyList")

    if not list then
        return Retry
    end

    local found = false

    local size = list:get_field("mSize")
    
    for i=0,size-1 do
        local v = list[i]

        if v then

            local health = v:get_field("<HitPoint>k__BackingField")
            if not health then
                return Retry
            end


            local hp = health:call("get_CurrentHitPoint")
            local max = health:call("get_DefaultHitPoint")

            if hp > 1 then
                health:call("set_CurrentHitPoint", 1)
                found = true
            end
        end
    end
    
    if not found then
        return Retry
    end

    return Success
end

local function CCEMaxHP()
    local enemyman = sdk.get_managed_singleton("app.ropeway.EnemyManager")

    if not enemyman then
        return Retry
    end

    local list = enemyman:get_field("<ActiveEnemyList>k__BackingField")--enemyman:call("get_ActiveEnemyList")

    if not list then
        return Retry
    end

    local found = false

    local size = list:get_field("mSize")
    
    for i=0,size-1 do
        local v = list[i]

        if v then

            local health = v:get_field("<HitPoint>k__BackingField")
            if not health then
                return Retry
            end


            local hp = health:call("get_CurrentHitPoint")
            local max = health:call("get_DefaultHitPoint")


            if hp < max then
                    
                health:call("set_CurrentHitPoint", max)
                
                found = true
            end
        end
    end
    
    if not found then
        return Retry
    end

    return Success
end




local function CCHeal()
    if ohko ~= nil then
        return retry
    end
    if invul ~= nil then
        return retry
    end

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return Retry
    end

    local health = condition:get_field("<HitPointController>k__BackingField")
    if not health then
        return Retry
    end


    local hp = health:call("get_CurrentHitPoint")
    local max = health:call("get_DefaultHitPoint")

    local del = max // 4

    if hp > max - del / 2 then
        return Retry
    end
    
    if hp + del > max then
        hp = max
    else
        hp = hp + del
    end

    health:call("set_CurrentHitPoint", hp)
    
    return Success
end

local function CCOneHP()
    if ohko ~= nil then
        return retry
    end
    if invul ~= nil then
        return retry
    end

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return Retry
    end

    local health = condition:get_field("<HitPointController>k__BackingField")
    if not health then
        return Retry
    end


    local hp = health:call("get_CurrentHitPoint")

    if hp < 2 then
        return Retry
    end
    
    health:call("set_CurrentHitPoint", 1)
    
    return Success
end

local function CCMaxHP()
    if ohko ~= nil then
        return retry
    end
    if invul ~= nil then
        return retry
    end

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return Retry
    end

    local health = condition:get_field("<HitPointController>k__BackingField")
    if not health then
        return Retry
    end


    local hp = health:call("get_CurrentHitPoint")
    local max = health:call("get_DefaultHitPoint")

    if hp >= max then
        return Retry
    end
    
    health:call("set_CurrentHitPoint", max)
    
    return Success
end

local function CCOHKO()
    if ohko ~= nil then
        return retry
    end
    if invul ~= nil then
        return retry
    end

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return Retry
    end

    local health = condition:get_field("<HitPointController>k__BackingField")
    if not health then
        return Retry
    end


    local hp = health:call("get_CurrentHitPoint")
    
    ohko = hp
    
    return Success
end

local function CCInvul()
    if ohko ~= nil then
        return retry
    end
    if invul ~= nil then
        return retry
    end

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition

    if not condition then
        return Retry
    end

    local health = condition:get_field("<HitPointController>k__BackingField")
    if not health then
        return Retry
    end


    local hp = health:call("get_CurrentHitPoint")
    
    invul = hp
    
    return Success
end

function CCGive()
    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local player = playman:call("get_CurrentPlayer")

    if not player then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local equipment = condition:get_field("<Equipment>k__BackingField")
    if not equipment then
        return Retry
    end

    local numslots = inventory:get_field("_CurrentSlotSize")

    CCLog("slots: " .. numslots)

    local mainslot = inventory:call("get_MainSlot")
    if not mainslot then
        return Retry
    end

    local mainslotid = mainslot:call("get_Index")
    CCLog("main slot: " .. mainslotid)

    inventory:call("unequipSlot", mainslotid)


    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end

    local slot = slots[3]
    if not slot then
        return Retry
    end

    local stock = slot:get_field("_Stock")
    if not stock then
        return Retry
    end

    local item = stock:get_field("DefaultItem")
    if not item then
        return Retry
    end

    local weap = item:get_field("WeaponId")
    if not weap then
        return Retry
    end

    CCLog("slot 0 weapon: " .. weap)

    slot:call("remove")

    slot:call("set_WeaponType", 9)
    slot:call("set_WeaponParts", 1)

    inventory:call("equipSlot", 3)

    local mainarm = equipment:get_field("<MainWeapon>k__BackingField")
    if not mainarm then
        return Retry
    end

    mainarm:call("setParts",1)
    
    return Success
end

function CCGiveHeal(item)

    CCLog("giving item: " .. item)

    local itemid = healing[item]

    CCLog("giving itemid: " .. itemid)

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local numslots = inventory:get_field("_CurrentSlotSize")

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end


    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")

            CCLog("slot " .. i .. " empty " .. tostring(empty))

            if empty then
                CCLog("adding to slot: " .. i)
                slot:call("set_ItemID", itemid)
                return Success
            end
        end
    end

    return Retry
end

function CCGiveWeap(item)

    if item == "grenage" then item = "grenade" end

    local itemid = weapon[item]
    local big = weaponbig[item]
    local bullet = weaponammo[item]

    CCLog('item ' .. item .. ' big ' .. tostring(big))

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end


    local equipman = sdk.get_managed_singleton(sdk.game_namespace("EquipmentManager"))

    if not equipman then
        return Retry
    end

    local itemman = sdk.get_managed_singleton("app.ropeway.gamemastering.InventoryManager")

    if not itemman then
        return Retry
    end


    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local numslots = inventory:get_field("_CurrentSlotSize")

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end

    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")
            if not empty then
                local eid = slot:call("get_WeaponType")

                if eid == itemid then

                    if item == "grenade" or item == "flash" then
                        local cur = slot:call("get_Number")
                        local max = slot:call("get_MaxNumber")
    
                        if max-cur>0 then
                            slot:call("set_Number",cur+1)
                            return Success
                        else
                            return Retry
                        end
                    else
                        return Retry
                    end
                end
            end
        end
    end

    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")


            if empty then

                if big and (i==numslots - 1) then
                    return Retry
                end

                if big then 
                    local slot2 = slots[i+1]
                    empty = slot2:call("get_IsBlank")
                    if not empty then
                        return Retry
                    end
                end

                

                if big and (i==3) then
                    local slot2 = slots[i+1]
                    empty = slot2:call("get_IsBlank")
                    if not empty then
                        return Retry
                    end
                    local slot3 = slots[i+2]
                    empty = slot3:call("get_IsBlank")
                    if not empty then
                        return Retry
                    end
                    slot:call("set_ItemID", 1)
                end

                CCLog("adding to slot: " .. i)
                --slot:call("set_WeaponType", itemid)


                if item == "grenade" or item == "flash" then
                    itemman:call("addAndEquipMainWeapon", itemid, 1, bullet)
                else
                    itemman:call("addAndEquipMainWeapon", itemid, 5, bullet)
                end

                if big and (i==3) then
                    --nventory:call("exchangeSlot", 3, 4)
                    --itemman:call("exchangeStock", 3, 4)
                    --slot:call("set_Index",3)
                    slot:call("remove")
                end

                return Success
            end
        end
    end



    return Retry
end


function CCGiveAmmo(item)

    CCLog("giving item: " .. item)

    local itemid = ammo[item]

    CCLog("giving itemid: " .. itemid)

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local numslots = inventory:get_field("_CurrentSlotSize")

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end


        
    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")

            if not empty then
                local eid = slot:call("get_ItemID")

                if eid == itemid then
                    local cur = slot:call("get_Number")
                    local max = slot:call("get_MaxNumber")

                    if max-cur>4 then
                        slot:call("set_Number",cur+5)
                        return Success
                    end

                end
            end
        end
    end

    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")

            if empty then
                slot:call("set_ItemID", itemid)
                slot:call("set_Number",5)
                return Success
            end
        end
    end

    return Retry
end

function CCHealUp()

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local numslots = inventory:get_field("_CurrentSlotSize")

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end


    local found = false
        
    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")

            if not empty then
                local eid = slot:call("get_ItemID")

                local to = healup[eid]
                if to ~=nil then
                    found = true
                    slot:call("set_ItemID", to)
                end
            end
        end
    end

    if found then
        return Success
    end

    return Retry
end

function CCHealDown()

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local numslots = inventory:get_field("_CurrentSlotSize")

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end


    local found = false
        
    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")

            if not empty then
                local eid = slot:call("get_ItemID")

                local to = healdown[eid]
                if to ~=nil then
                    found = true
                    slot:call("set_ItemID", to)
                end
            end
        end
    end

    if found then
        return Success
    end

    return Retry
end


function CCFillWeap()

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end


    local slot = inventory:call("get_MainSlot")
    if not slot then
        return Retry
    end
        
    local cur = slot:call("get_Number")
    local max = slot:call("get_MaxNumber")

    if cur<max then
        slot:call("set_Number",max)
        return Success
    end

    return Retry
end

function CCEmptyWeap()

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end


    local slot = inventory:call("get_MainSlot")
    if not slot then
        return Retry
    end
        
    local cur = slot:call("get_Number")

    if cur>0 then
        slot:call("set_Number",0)
        return Success
    end

    return Retry
end


function CCTakeHeal()

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local numslots = inventory:get_field("_CurrentSlotSize")

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end


        
    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")

            if not empty then
                local eid = slot:call("get_ItemID")

                if eid > 0 and eid < 12 then
                    slot:call("remove")
                    return Success
                end
            end
        end
    end


    return Retry
end

function CCGiant()
    if giant ~= nil then
        return retry
    end
    if tiny ~= nil then
        return retry
    end

    giant = 1.5

    return Success
end

function CCTiny()
    if giant ~= nil then
        return retry
    end
    if tiny ~= nil then
        return retry
    end

    tiny = 0.33

    return Success
end

function CCEGiant()
    if esize ~= nil then
        return retry
    end

    esize = 1.5

    return Success
end

function CCETiny()
    if esize ~= nil then
        return retry
    end

    esize = 0.33

    return Success
end


function SetScale(val)
    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local head = condition:get_field("<HeadJoint>k__BackingField")
    if not head then
        return Retry
    end

    local transform = head:call("get_Owner")
    if not transform then
        return Retry
    end

    local scale = transform:call("get_LocalScale")
    if not scale then
        return Retry
    end

    scale.x = val
    scale.y = val
    scale.z = val

    transform:call("set_LocalScale", scale)

    return Success
end

function SetEnemyScale(val)
    local enemyman = sdk.get_managed_singleton("app.ropeway.EnemyManager")

    if not enemyman then
        return Retry
    end

    local list = enemyman:get_field("<ActiveEnemyList>k__BackingField")--enemyman:call("get_ActiveEnemyList")

    if not list then
        return Retry
    end

    local found = false

    local size = list:get_field("mSize")

    for i=0,size-1 do
        local v = list[i]

        if v then
            local cont = v:get_field("<EnemyCharacterController>k__BackingField")
            if  cont then

                local head = cont:get_field("<FollowJoint>k__BackingField")
                if head then
            

                    local transform = head:call("get_Owner")
                    if not transform then
                        return Retry
                    end
                
                    local scale = transform:call("get_LocalScale")
                    if not scale then
                        return Retry
                    end
                
                    scale.x = val
                    scale.y = val
                    scale.z = val
                
                    transform:call("set_LocalScale", scale)

                    found = true
                end

                local scont = cont:get_field("SubController")

                if scont then
                    head = scont:get_field("<FollowJoint>k__BackingField")
                    if head then


                        local transform = head:call("get_Owner")
                        if not transform then
                            return Retry
                        end

                    
                        local scale = transform:call("get_LocalScale")
                        if not scale then
                            return Retry
                        end
                    

                        scale.x = val
                        scale.y = val
                        scale.z = val
                    
                        transform:call("set_LocalScale", scale)

                        found = true
                    else
                        head = scont:get_field("<OwnerGameObject>k__BackingField")

                        if head then

    
                            local transform = head:call("get_Transform")
                            if not transform then
                                return Retry
                            end
    
                        
                            local scale = transform:call("get_LocalScale")
                            if not scale then
                                return Retry
                            end
                        
    
                            scale.x = val
                            scale.y = val
                            scale.z = val
                        
                            transform:call("set_LocalScale", scale)
    
                            found = true
                        end

                    end
                end

            end
        end
        
    end


    if not found then
        return Retry
    end

    return Success
end

function CCTakeAmmo()
    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local numslots = inventory:get_field("_CurrentSlotSize")

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end


        
    for i=0,numslots-1 do
        local slot = slots[i]
        
        if slot then
            local empty = slot:call("get_IsBlank")

            if not empty then
                local eid = slot:call("get_ItemID")

                if eid > 14 and eid < 28 then

                    local cur = slot:call("get_Number")

                    if cur>5 then
                        slot:call("set_Number",cur-5)
                        return Success
                    end

                    slot:call("remove")
                    return Success
                end
            end
        end
    end


    return Retry
end

function CCTakeWeap()

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end

    local mainslot = inventory:call("get_MainSlot")
    if not mainslot then
        return Retry
    end

    local mainslotid = mainslot:call("get_Index")
    
    if mainslotid == -1 then
        return Retry
    end

    inventory:call("unequipSlot", mainslotid)
    inventory:call("removeSlot", mainslotid)
        
    CCLog("taking slot: " .. mainslotid)

    --local slot = slots[mainslotid]
    
    --slot:call("remove")

    return Success
end


function CCUnequipWeap()

    local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))

    if not playman then
        return Retry
    end

    local condition = playman:call("get_CurrentPlayerCondition")
        
    if not condition then
        return Retry
    end

    local inventory = condition:get_field("<Inventory>k__BackingField")
    if not inventory then
        return Retry
    end

    local slots = inventory:get_field("_Slots")
    if not slots then
        return Retry
    end

    local mainslot = inventory:call("get_MainSlot")
    if not mainslot then
        return Retry
    end

    local mainslotid = mainslot:call("get_Index")
    
    if mainslotid == -1 then
        return Retry
    end

    inventory:call("unequipSlot", mainslotid)
        
    
    return Success
end

function CCRunRequest()
    print(CCRequestString)
    local request = CCRequest:from_json(CCRequestString)
    --print(request)
    if request == nil then
        return ""
    end


    --go ahead and create a response and we can just fill it in as we go
    local response = CCResponse:new()
    --print(response)
    --now we handle the code
    response.id = request.id
    local res = Failure

    local ready = false
    if not isReady() then
        response.status = Retry
        restr = CCResponse:to_json(response)
        return restr
    end

    local code = request.code
    if code == "kill" then
        res = CCKill()
    end
    if code == "damage" then
        res = CCDamage()
    end
    if code == "heal" then
        res = CCHeal()
    end

    if code == "onehp" then
        res = CCOneHP()
    end
    if code == "full" then
        res = CCMaxHP()
    end    


    if code == "edamage" then
        res = CCEDamage()
    end
    if code == "eheal" then
        res = CCEHeal()
    end

    if code == "eonehp" then
        res = CCEOneHP()
    end
    if code == "efull" then
        res = CCEMaxHP()
    end   


    if code == "healup" then
        res = CCHealUp()
    end
    if code == "healdown" then
        res = CCHealDown()
    end

    if code == "fast" then
        res = CCFast()
        if res == Success then
            speedtimer = request.duration / 1000.0
            speedid = request.id
            response.timeRemaining = request.duration
        end
    end
    if code == "slow" then
        res = CCSlow()
        if res == Success then
            speedtimer = request.duration / 1000.0
            speedid = request.id
            response.timeRemaining = request.duration
        end
    end
    if code == "hyper" then
        res = CCHyper()
        if res == Success then
            speedtimer = request.duration / 1000.0
            speedid = request.id
            response.timeRemaining = request.duration
        end
    end

    if code == "efast" then
        res = CCEFast()
        if res == Success then
            espeedtimer = request.duration / 1000.0
            espeedid = request.id
            response.timeRemaining = request.duration
        end
    end
    if code == "eslow" then
        res = CCESlow()
        if res == Success then
            espeedtimer = request.duration / 1000.0
            espeedid = request.id
            response.timeRemaining = request.duration
        end
    end


    if code == "wide" then
        res = CCWide()
        if res == Success then
            fovtimer = request.duration / 1000.0
            fovid = request.id
            response.timeRemaining = request.duration
        end
    end
    if code == "narrow" then
        res = CCNarrow()
        if res == Success then
            fovtimer = request.duration / 1000.0
            fovid = request.id
            response.timeRemaining = request.duration
        end
    end

    if code == "give" then
        res = CCGive()
    end

    if code == "takeheal" then
        res = CCTakeHeal()
    end

    if code == "takeweap" then
        res = CCTakeWeap()
    end
    
    if code == "unequipweap" then
        res = CCUnequipWeap()
    end

    if code == "fillweap" then
        res = CCFillWeap()
    end

    if code == "emptyweap" then
        res = CCEmptyWeap()
    end

    if code == "takeammo" then
        res = CCTakeAmmo()
    end    

    if code == "giant" then
        res = CCGiant()
        if res == Success then
            gianttimer = request.duration / 1000.0
            giantid = request.id
            response.timeRemaining = request.duration
        end
    end

    if code == "tiny" then
        res = CCTiny()
        if res == Success then
            tinytimer = request.duration / 1000.0
            tinyid = request.id
            response.timeRemaining = request.duration
        end
    end

    if code == "egiant" then
        res = CCEGiant()
        if res == Success then
            esizetimer = request.duration / 1000.0
            esizeid = request.id
            response.timeRemaining = request.duration
        end
    end

    if code == "etiny" then
        res = CCETiny()
        if res == Success then
            esizetimer = request.duration / 1000.0
            esizeid = request.id
            response.timeRemaining = request.duration
        end
    end    

    if code:startswith("spawn_") then

        local items = code:split("_")

        res = CCSpawn(items[2])
    end 

    if code:startswith("giveheal_") then

        local items = code:split("_")

        res = CCGiveHeal(items[2])
    end

    if code:startswith("giveweap_") then

        local items = code:split("_")

        res = CCGiveWeap(items[2])
    end    

    if code:startswith("giveammo_") then

        local items = code:split("_")

        res = CCGiveAmmo(items[2])
    end 

    if code == "ohko" then
        res = CCOHKO()
        if res == Success then
            ohkotimer = request.duration / 1000.0
            ohkoid = request.id
            response.timeRemaining = request.duration
        end
    end
    if code == "invul" then
        res = CCInvul()
        if res == Success then
            invultimer = request.duration / 1000.0
            invulid = request.id
            response.timeRemaining = request.duration
        end 
    end

    response.status = res


    
    --print(response.id)
    print(response.status)
    if response.status == Success then
        --now we create a string to send the player
        --SendMessage(string.format("<COL RED>%s</COL> has sent <PL>: %s",request.viewer,CCCodeToName(code)))
    end
    restr = CCResponse:to_json(response)
    print(restr)
    return restr
end

math.randomseed(os.time())

local function SendUpdate(id, type)
    local response = CCResponse:new()
    response.id = id
    response.status = type
    local str = CCResponse:to_json(response)

    CCSendUpdate(str)
end

local function UpdateTimers()
    
    local application = sdk.get_native_singleton("via.Application")

    if not application then
        return nil
    end
    local app_type = sdk.find_type_definition("via.Application")
    

    local time = sdk.call_native_func(application, app_type, "get_UpTimeSecond")--CurrentElapsedTimeMillisecond")

    if lasttime > 0 then
        local deltaTime = time - lasttime

        --CCLog("giant " .. gianttimer .. " delta " .. deltaTime)

        if isReady() then
            if paused then

                if ohkotimer > 0 then SendUpdate(ohkoid, Resumed) end
                if invultimer > 0 then SendUpdate(invulid, Resumed) end
                if tinytimer > 0 then SendUpdate(tinyid, Resumed) end
                if gianttimer > 0 then SendUpdate(giantid, Resumed) end
                if speedtimer > 0 then SendUpdate(speedid, Resumed) end
                if espeedtimer > 0 then SendUpdate(espeedid, Resumed) end
                if fovtimer > 0 then SendUpdate(fovid, Resumed) end
                if esizetimer > 0 then SendUpdate(esizeid, Resumed) end
                
                paused = false
            end

            if deltaTime < 0 then
                deltaTime = 0
            end

            if ohkotimer > 0 then
                ohkotimer = ohkotimer - deltaTime
            end
            if invultimer > 0 then
                invultimer = invultimer - deltaTime
            end  
            
            if tinytimer > 0 then
                tinytimer = tinytimer - deltaTime
            end
            if gianttimer > 0 then
                gianttimer = gianttimer - deltaTime
            end
            if speedtimer > 0 then
                speedtimer = speedtimer - deltaTime
            end
            if espeedtimer > 0 then
                espeedtimer = espeedtimer - deltaTime
            end
            if fovtimer > 0 then
                fovtimer = fovtimer - deltaTime
            end
            if esizetimer > 0 then
                esizetimer = esizetimer - deltaTime
            end
        else

            if not paused then

                if ohkotimer > 0 then SendUpdate(ohkoid, Pause) end
                if invultimer > 0 then SendUpdate(invulid, Pause) end
                if tinytimer > 0 then SendUpdate(tinyid, Pause) end
                if gianttimer > 0 then SendUpdate(giantid, Pause) end
                if speedtimer > 0 then SendUpdate(speedid, Pause) end
                if espeedtimer > 0 then SendUpdate(espeedid, Pause) end
                if fovtimer > 0 then SendUpdate(fovid, Pause) end
                if esizetimer > 0 then SendUpdate(esizeid, Pause) end
                
                paused = true

                if gianttimer > 0 or tinytimer > 0 and not scalehold then
                    SetScale(1.0)
                end

                scalehold = false
            end
        end
    end

    lasttime = time
end

local function on_pre_get_timescale(args)
    CCLog("Playing Event")
    if not paused then
        if gianttimer > 0 or tinytimer > 0 then
            SetScale(1.0)
            scalehold = true
        end
    end
end

local function on_post_get_timescale(retval)

    return retval
end

sdk.hook(sdk.find_type_definition("app.ropeway.fsmv2.PlayEvent"):get_method("start"), on_pre_get_timescale, on_post_get_timescale)


re.on_frame(function()

    local flowman = sdk.get_managed_singleton("app.ropeway.gamemastering.MainFlowManager")
    if not flowman then
        CCLog('no flow manager')
        return
    end

    local state = flowman:get_field("_CurrentMainState")
    if state < 6 or state > 7 and state ~= 9 then

        if spawns then
            local scene = sdk.call_native_func(sdk.get_native_singleton("via.SceneManager"), sdk.find_type_definition("via.SceneManager"), "get_CurrentScene") 
            local spawned_prefabs_folder = scene:call("findFolder", "ModdedTemporaryObjects") or scene:call("findFolder", "GUI_Rogue")

            spawned_prefabs_folder:call("deactivate") --fixes infinite loading
            spawned_prefabs_folder:call("activate")
        end

        spawns = false
    else
        spawns = true
    end
end)

re.on_pre_application_entry("UpdateBehavior", function()
    --main loop access, update timers in here
    UpdateTimers()

    if fovtimer <= 0 then
        if FOV ~= 81.0 then
            
                local response = CCResponse:new()
                response.id = fovid
                response.status = Stopped
                local str = CCResponse:to_json(response)

                CCSendUpdate(str)

                FOV = 81.0
            
        end     
    end

    if esizetimer <= 0 then
        if esize ~= nil then
            if SetEnemyScale(1.0) == Success then
                local response = CCResponse:new()
                response.id = esizeid
                response.status = Stopped
                local str = CCResponse:to_json(response)

                CCSendUpdate(str)

                esize = nil
            end
        end
    else
        if esize ~= nil then
            SetEnemyScale(esize)
        end        
    end

    if gianttimer <= 0 then
        if giant ~= nil then
            if SetScale(1.0) == Success then
                local response = CCResponse:new()
                response.id = giantid
                response.status = Stopped
                local str = CCResponse:to_json(response)

                CCSendUpdate(str)

                giant = nil
                scalehold = false
            end
        end
    else
        if giant ~= nil and not scalehold and not paused then
            SetScale(giant)
        end        
    end

    if tinytimer <= 0 then
        if tiny ~= nil then
            if SetScale(1.0) == Success then
                local response = CCResponse:new()
                response.id = tinyid
                response.status = Stopped
                local str = CCResponse:to_json(response)

                CCSendUpdate(str)

                tiny = nil
                scalehold = false
            end
        end
    else
        if tiny ~= nil and not scalehold and not paused then
            SetScale(tiny)
        end        
    end

    if speedtimer <= 0 then
        if speed ~= nil then
            if SetSpeed(1.0) == Success then
                local response = CCResponse:new()
                response.id = speedid
                response.status = Stopped
                local str = CCResponse:to_json(response)

                CCSendUpdate(str)

                speed = nil
            end
        end
    else
        if speed ~= nil then
            SetSpeed(speed)
        end        
    end

    if espeedtimer <= 0 then
        if espeed ~= nil then
            if SetEnemySpeed(1.0) == Success then
                local response = CCResponse:new()
                response.id = espeedid
                response.status = Stopped
                local str = CCResponse:to_json(response)

                CCSendUpdate(str)

                espeed = nil
            end
        end
    else
        if espeed ~= nil then
            SetEnemySpeed(espeed)
        end        
    end

    if ohkotimer <= 0 then
        if ohko ~= nil then
            
            local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))
    
            if not playman then
                return
            end
        
            local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition
        
            if not condition then
                return
            end
        
            local health = condition:get_field("<HitPointController>k__BackingField")
            if not health then
                return
            end
        
            local hp = health:call("get_CurrentHitPoint")

            if hp > 0 then
                health:call("set_CurrentHitPoint", ohko)
                ohko = nil

                local response = CCResponse:new()
                response.id = ohkoid
                response.status = Stopped
                local str = CCResponse:to_json(response)

                CCSendUpdate(str)
            end
        end
    else
        if ohko ~= nil then
            local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))
    
            if not playman then
                return
            end
        
            local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition
        
            if not condition then
                return
            end
        
            local health = condition:get_field("<HitPointController>k__BackingField")
            if not health then
                return
            end

            local hp = health:call("get_CurrentHitPoint")
        
            if hp > 0 then
                health:call("set_CurrentHitPoint", 1)
            end
        end        
    end

    if invultimer <= 0 then
        if invul ~= nil then

            local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))
    
            if not playman then
                return
            end
        
            local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition
        
            if not condition then
                return
            end
        
            local health = condition:get_field("<HitPointController>k__BackingField")
            if not health then
                return
            end

            local hp = health:call("get_CurrentHitPoint")
            if hp > 0 then
                health:call("set_CurrentHitPoint", invul)
                invul = nil

                local response = CCResponse:new()
                response.id = invulid
                response.status = Stopped
                local str = CCResponse:to_json(response)

                CCSendUpdate(str)
            end
        end
    else
        if invul ~= nil then
            local playman = sdk.get_managed_singleton(sdk.game_namespace("PlayerManager"))
    
            if not playman then
                return
            end
        
            local condition = playman:call("get_CurrentPlayerCondition") --playman.CurrentPlayerCondition
        
            if not condition then
                return
            end
        
            local health = condition:get_field("<HitPointController>k__BackingField")
            if not health then
                return
            end
        
            local hp = health:call("get_CurrentHitPoint")
            local max = health:call("get_DefaultHitPoint")

            if hp > 0 then
                health:call("set_CurrentHitPoint", max)
            end

            
        end        
    end

end)
